module Numbered;

import std.string;

class Numbered {
    const int NOT_FOUND = -1;
    const int TRIMMING = 1;
    const char[] N_0TO9 = "0123456789";
    bool trimmed;
    int a_length, k, non_number_length, span, trimmed_sequence_length;
    char[] error, f, ft, pt, s, st;

    private int leadingNumbers(char[] full) {
        int fullLength = full.length;
        int k, q, m;
        char[] c;
        for(k = 0; k < fullLength; k += 1 ) {
            m = k + 1;
            c = full[k..m];
            q = find(N_0TO9, c);
            if(q >= 0) {
                continue;
            } else {
                break;
            }

        }

        return k;
    }

    private int trailingNumbers(char[] full) {
        int fullLength = full.length;
        int k, q, m, n;
        char[] c;
        for(n = 0; n < fullLength; n += 1 ) {
            k = fullLength - 1 - n;
            m = k + 1;
            c = full[k..m];
            q = find(N_0TO9, c);
            if(q >= 0) {
                continue;
            } else {
                break;
            }

        }

        return n;
    }

    public bool trimmed_sequence() {
        int size, u;
        char[] q;
/*
a: -i1-37
first part of a: -i1-
second part of a: 37
trimmed sequence: -i1
first part of trimmed sequence: -i
second part of trimmed sequence: 1
*/

// Trimming the first part of a
        trimmed_sequence_length = f.length - TRIMMING;
        pt = f[0..trimmed_sequence_length];
        trimmed = true;

        u = trailingNumbers(pt);
        if(u == 0) {
            trimmed = false;
            return trimmed;
        }

        span = u;
        non_number_length = trimmed_sequence_length - span;

// Copying the second part of trimmed sequence
        st = pt[non_number_length..$];

// Copying the first part of trimmed sequence
        ft = pt[0..non_number_length];
        return true;
    }

    this(char[] a) {
        int size;
        char[] q;

        trimmed = false;
        a_length = a.length;

        span = trailingNumbers(a);
        non_number_length = a_length - span;

// Copying the second part of a
        s = a[non_number_length..$];

// Copying the first part of a
        f = a[0..non_number_length];
    }

    public char[] parameter() {
        if(trimmed) {
            return ft;
        } else {
            return f;
        }

    }

    public int number() {
        return atoi(s);
    }

    public int subnumber() {
        int k = NOT_FOUND;

        if(trimmed) {
            k = atoi(st);
        }

        return k;
    }

};

