module TimeName;

import std.date;
import std.stream;
import std.string;

int sn;

class TimeName {
    const char[] HYPHEN = "-";
    const char[] SERIAL_TEXT = "serial.txt";
    char[] base, error, extension, name, timeName;

    private bool setSerialNumber() {
// Producing a new serial number
        sn += 1;
        char[] serial_number = std.string.toString(sn);

        try {
// Writing the serial number
            Stream file = new BufferedFile(SERIAL_TEXT, FileMode.OutNew);
            file.writef(serial_number);
            file.writef(newline);
            file.close();
        } catch(OpenException e1) {
            error = "OpenException e1";
            return false;
        }

// First part of a file name
        name = base;
        name ~= serial_number;
        name ~= HYPHEN;
        return true;
    }

    private bool zeroSerialNumber() {
// Producing a new serial number
        sn = 0;
        char[] serial_number = std.string.toString(sn);

        try {
            Stream file = new BufferedFile(SERIAL_TEXT, FileMode.OutNew);
            file.writef(serial_number);
            file.writef(newline);
            file.close();
        } catch(OpenException e24) {
            error = "OpenException e24";
            return false;
        }

        name = base;
        name ~= serial_number;
        name ~= HYPHEN;
        return true;
    }

    private void readSerialNumber() {
        try {
            Stream buffered = new BufferedFile(SERIAL_TEXT); 
            char[] s = buffered.readLine();
            if(s == null) {
                zeroSerialNumber();
                return;
            }

            sn = atoi(s);
            buffered.close();
        } catch(OpenException e23) {
            error = "OpenException e23";
            zeroSerialNumber();
        } catch(ReadException e28) {
            error = "ReadException e28";
            zeroSerialNumber();
        }

    }

    public char[] getTimeName() {
        return timeName;
    }

    public char[] inquiry() {
        return error;
    }

    public char[] temporaryName(bool serial) {
        d_time now = std.date.getUTCtime();
        char[] d = std.date.toString(now);
        char[] MINUTE = d[14..16];
        char[] SECOND = d[17..19];

        if(serial) {
            setSerialNumber();
        }

        char[] ti = name;
        ti ~= MINUTE;
        ti ~= HYPHEN;
        ti ~= SECOND;
        ti ~= extension;
        if(ti == timeName) {
            setSerialNumber();

            char[] y = name;
            y ~= MINUTE;
            y ~= HYPHEN;
            y ~= SECOND;
            y ~= extension;
            ti = y;
        }

        timeName = ti;
        return timeName;
    }

    this(char[] b, char[] e) {
        base = b;
        extension = e;
        name = base;
        readSerialNumber();
    }

}

