module viewXBM;

/*
viewXBM DFL Version 1.02
Copyright 2017 Sogaya

Digital Mars D Compiler v1.030
D Forms Library Version 0.9.8 Beta (DFL)

*/

import dfl.all;
import dfl.internal.winapi;
import Kun;
import KunCode;
import std.string;

const int ID_ICON = 101;
const int XBM_HEIGHT = 40;
const int XBM_WIDTH = 40;
const int XBM_WIDTH_1 = XBM_WIDTH + 1;

class viewXBM: dfl.form.Form {
    dfl.label.Label[XBM_HEIGHT][XBM_WIDTH_1] cell;
    Kun kun;

    this(Kun ku) {
        kun = ku;
        initializeViewXBM();
        menu = new MainMenu;

        auto fileMenu = new MenuItem;
        fileMenu.text = "&File";
        menu.menuItems.add(fileMenu);

        auto PDFmenuItem = new MenuItem;
        PDFmenuItem.text = "&PDF";
        fileMenu.menuItems.add(PDFmenuItem);
        PDFmenuItem.click ~= (Object sender, EventArgs ea) {
            viewXBM_PDF();
        };

        auto exitMenuItem = new MenuItem;
        exitMenuItem.text = "&Exit";
        fileMenu.menuItems.add(exitMenuItem);
        exitMenuItem.click ~= (Object sender, EventArgs ea) {
            Application.exitThread;
        };

        icon = Application.resources.getIcon(ID_ICON);
    }
    
    private void viewXBM_PDF() {
        ShellExecuteA(null, null, std.string.toStringz("viewXBM.pdf"), null, null, SW_SHOWNORMAL);
    }

    private void initializeViewXBM() {
        char[] EMPTY = "";
        const int MENU_HEIGHT = 20;
        const int BORDER = 0;

        int cell_height = kun.cell_height;
        int cell_width = kun.cell_width;
        int client_height = cell_height * XBM_HEIGHT + MENU_HEIGHT + BORDER;
        int client_width = cell_width * XBM_WIDTH + BORDER;
        int data_height = kun.data_height;
        int data_width = kun.data_width;

        if(cell_height < 2) {
            cell_height = 2;
        }

        if(cell_width < 2) {
            cell_width = 2;
        }

        formBorderStyle = dfl.all.FormBorderStyle.FIXED_SINGLE;
        maximizeBox = false;
        minimizeBox = false;
        startPosition = dfl.all.FormStartPosition.CENTER_SCREEN;
        text = "viewXBM";
        clientSize = dfl.all.Size(client_width, client_height);

        int cell_left, cell_top;
//        int q = 1;
        for(int i = 0; i < data_height; ++i) {
            cell_top = cell_height * i;

            for(int k = 1; k <= data_width; ++k) {
                cell_left = cell_width * ( k - 1 );

                with( cell[k][i] = new dfl.label.Label ) {
                    name = "L"; // ~ std.string.toString(q++);
                    text = EMPTY; 
                    bounds = dfl.all.Rect(cell_left, cell_top, cell_width, cell_height); 

                    if( kun.xbmBool(i, k) ) {
                        backColor = Color(0, 0, 0x80); // navy
                    } else {
                        backColor = Color(0xFF, 0xFF, 0xFF); // white
                    }

                    parent = this;
                }

            }

        }

    }

}

int main() {
    bool drawXbm = false;
    const char[][] ARGS = ["-r-"];
    const int CSV_SPECIFIED = 0;
    const int KUN_EXPAND = 1;
    const int KUN_SHRINK = 2;
    const int NOT_TREATED_AS_TRUE = 3;
    const int RECOVERY = 4;
    const int SHARP_TEXT = 5;
    const int TREATED_AS_FALSE = 6;
    const int VERSION_COMMENTS = 8;
    const int VERSION_GUIDE = 7;
    const int XBM_FILE_ERROR = 9;
    const int XBM_READ = 10;
    const int XBM_TO_CSV = 11;
    int d = 0;
    Kun kun = new Kun(d);
	char[][] args;

	args = Environment.getCommandLineArgs();
    KunCode kc = kun.readXbm(args);
    switch(kc.code) {
    case XBM_READ:
        drawXbm = true;
        break;
    default:
        break;
    }

    if(kc.newXbm) {
        kc = kun.readXbm(ARGS);
        switch(kc.code) {
        case XBM_READ:
            drawXbm = true;
            break;
        default:
            break;
        }

    } else {
        if(! drawXbm) {
            return 0;
        }

    }

    try {
        Application.run( new viewXBM(kun) );
    } catch(Object o) {
        msgBox(o.toString(), "viewXBM run error", MsgBoxButtons.OK, MsgBoxIcon.ERROR);
    }

    return 1;
}

